unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math, Spin;

type
  TBooleanArray = array of boolean;

  TDoubleBooleanArray = array of TBooleanArray;

  TMainForm = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    uc0: TCheckBox;
    uc1: TCheckBox;
    uc2: TCheckBox;
    uc3: TCheckBox;
    uc4: TCheckBox;
    uc5: TCheckBox;
    uc6: TCheckBox;
    uc7: TCheckBox;
    uc8: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    ec0: TCheckBox;
    ec7: TCheckBox;
    ec6: TCheckBox;
    ec5: TCheckBox;
    ec4: TCheckBox;
    ec3: TCheckBox;
    ec2: TCheckBox;
    ec1: TCheckBox;
    ec8: TCheckBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    SpinEditZ: TSpinEdit;
    SpinEditW: TSpinEdit;
    SpinEditH: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure DrawField(Field: TDoubleBooleanArray);
    procedure ControlState(S: boolean);
    function Die(Sum: integer): boolean;
    function Born(Sum: integer): boolean;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

uses
  Playground, Stats;

{$R *.dfm}

resourcestring
  LNG_EVERYTHING_DEAD = 'Die Kultur ist nach %d Generationen ausgestorben...';
  LNG_EQUAL = 'Nach %d Generationen wurde ein stabiler Zustand erreicht!';
  LNG_INVALID_NUMBER = 'Fehler: Ungltige Eingaben';

function RandomBoolean(): boolean; overload;
begin
  result := RandomRange(0, 1) = 1;
end;

function RandomBoolean(P: Extended): boolean; overload;
begin
  result := Random <= P;
end;

function CreateField(Width, Height: integer): TDoubleBooleanArray;
var
  i: integer;
begin
  SetLength(result, Width);
  for i := Low(result) to High(result) do
  begin
    SetLength(result[i], Height);
  end;
end;

procedure GenerateField(var Field: TDoubleBooleanArray; const P: Extended);
var
  i, j: integer;
begin
  for i := Low(Field) to High(Field) do
  begin
    for j := Low(Field[i]) to High(Field[i]) do
    begin
      Field[i][j] := RandomBoolean(P);
    end;
  end;
end;

function BoolVal(Value: boolean): Integer;
begin
  if Value then
    result := 1
  else
    result := 0;
end;

function KeyExists(A: TDoubleBooleanArray; k: integer): boolean; overload;
begin
  result := (k >= Low(A)) and (k <= High(A));
end;

function KeyExists(A: TBooleanArray; k: integer): boolean; overload;
begin
  result := (k >= Low(A)) and (k <= High(A));
end;

function SecurValue(Field: TDoubleBooleanArray; X, Y: integer): byte;
begin
  if KeyExists(Field, X) and KeyExists(Field[X], Y) then
    result := BoolVal(Field[X][Y])
  else
    result := 0;
end;

function Nachbarsumme(Field: TDoubleBooleanArray; X, Y: integer): byte;
begin
  result :=          SecurValue(Field, X-1, Y-1);
  result := result + SecurValue(Field, X  , Y-1);
  result := result + SecurValue(Field, X+1, Y-1);

  result := result + SecurValue(Field, X-1, Y  );
  result := result + SecurValue(Field, X+1, Y  );

  result := result + SecurValue(Field, X-1, Y+1);
  result := result + SecurValue(Field, X  , Y+1);
  result := result + SecurValue(Field, X+1, Y+1);
end;

function IsDead(Field: TDoubleBooleanArray): boolean;
var
  i, j: integer;
begin
  result := true;
  for i := Low(Field) to High(Field) do
  begin
    for j := Low(Field[i]) to High(Field[i]) do
    begin
      if Field[i][j] then
      begin
        result := false;
        exit;
      end;
    end;
  end;
end;

function Equal(FieldA, FieldB: TDoubleBooleanArray): boolean;
var
  i, j: integer;
begin
  result := true;
  if Low(FieldA)  <> Low(FieldB)  then exit;
  if High(FieldA) <> High(FieldB) then exit;
  for i := Low(FieldA) to High(FieldA) do
  begin
    if Low(FieldA[i])  <> Low(FieldB[i])  then exit;
    if High(FieldA[i]) <> High(FieldB[i]) then exit;
    for j := Low(FieldA[i]) to High(FieldA[i]) do
    begin
      if FieldA[i][j] <> FieldB[i][j] then
      begin
        result := false;
        exit;
      end;
    end;
  end;
end;

function DeepCopy(FieldSource: TDoubleBooleanArray): TDoubleBooleanArray;
var
  i, j: integer;
begin
  result := FieldSource;
  for i := Low(FieldSource) to High(FieldSource) do
  begin
    for j := Low(FieldSource[i]) to High(FieldSource[i]) do
    begin
      result[i][j] := FieldSource[i][j];
    end;
  end;
end;

function TMainForm.Die(Sum: integer): boolean;
begin
  result := true;
  if uc0.Checked and (Sum = uc0.Tag) then result := false;
  if uc1.Checked and (Sum = uc1.Tag) then result := false;
  if uc2.Checked and (Sum = uc2.Tag) then result := false;
  if uc3.Checked and (Sum = uc3.Tag) then result := false;
  if uc4.Checked and (Sum = uc4.Tag) then result := false;
  if uc5.Checked and (Sum = uc5.Tag) then result := false;
  if uc6.Checked and (Sum = uc6.Tag) then result := false;
  if uc7.Checked and (Sum = uc7.Tag) then result := false;
  if uc8.Checked and (Sum = uc8.Tag) then result := false;
end;

function TMainForm.Born(Sum: integer): boolean;
begin
  result := false;
  if ec0.Checked and (Sum = ec0.Tag) then result := true;
  if ec1.Checked and (Sum = ec1.Tag) then result := true;
  if ec2.Checked and (Sum = ec2.Tag) then result := true;
  if ec3.Checked and (Sum = ec3.Tag) then result := true;
  if ec4.Checked and (Sum = ec4.Tag) then result := true;
  if ec5.Checked and (Sum = ec5.Tag) then result := true;
  if ec6.Checked and (Sum = ec6.Tag) then result := true;
  if ec7.Checked and (Sum = ec7.Tag) then result := true;
  if ec8.Checked and (Sum = ec8.Tag) then result := true;
end;

function Process(Field: TDoubleBooleanArray): TDoubleBooleanArray;
var
  i, j: integer;
begin
  result := Field;
  for i := Low(Field) to High(Field) do
  begin
    for j := Low(Field[i]) to High(Field[i]) do
    begin
      // Wichtig: Vernderungen nicht im "Field" ausfhren, da sonst
      // die nachfolgenden Ergebnisse verflscht werden.

      if Field[i][j] then
      begin
        // Zelle lebt

        if MainForm.Die(Nachbarsumme(Field, i, j)) then
          result[i][j] := false;
      end
      else
      begin
        // Zelle ist tot

        if MainForm.Born(Nachbarsumme(Field, i, j)) then
          result[i][j] := true;
      end;
    end;
  end;
end;

function GetTotalCell(W, H: integer): Integer;
begin
  result := W * H;
end;

function GetLivingCell(Field: TDoubleBooleanArray): Integer;
var
  i, j: integer;
begin
  result := 0;

  for i := Low(Field) to High(Field) do
  begin
    for j := Low(Field[i]) to High(Field[i]) do
    begin
      if Field[i][j] then Inc(result);
    end;
  end;
end;

function LifeQuota(W, H: integer; Field: TDoubleBooleanArray): Extended;
var
  Total, Living: integer;

begin
  Total := GetTotalCell(W, H);
  Living := GetLivingCell(Field);

  result := Living / Total;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
  Spielfeld, NewSpielfeld: TDoubleBooleanArray;
  W, H, Z: integer;
  P: Extended;
  C: integer;
  Dead: boolean;
begin
  W := SpinEditW.Value;
  H := SpinEditH.Value;
  Z := SpinEditZ.Value;

  Spielfeld := CreateField(W, H);
  NewSpielfeld := CreateField(W, H);

  try
    P := StrToFloat(Edit3.Text);
  except
    ShowMessage(LNG_INVALID_NUMBER);
    Exit;
  end;

  ControlState(false);

  //Visible := false;
  PlayForm.Prepare(W, H, Z);
  PlayForm.Visible := true;
  StatForm.Prepare();
  StatForm.Visible := true;

  GenerateField(Spielfeld, P / 100);
  C := 0;

  repeat
    DrawField(Spielfeld);

    PlayForm.UpdateCaption(C);

    Dead := IsDead(Spielfeld);
    if Dead then
    begin
      ShowMessageFmt(LNG_EVERYTHING_DEAD, [C]);
    end;

    StatForm.DrawVal(GetLivingCell(Spielfeld), LifeQuota(W, H, Spielfeld));

    NewSpielfeld := DeepCopy(Process(Spielfeld));
    inc(C);

    // ToDo: Geht nicht!!!
    (* if Equal(Spielfeld, NewSpielfeld) then
    begin
      ShowMessageFmt(LNG_EQUAL, [C]);
    end; *)

    NewSpielfeld := DeepCopy(Spielfeld);
  until Application.Terminated or Dead;

  ControlState(true);
end;

procedure TMainForm.ControlState(S: boolean);
begin
  SpinEditW.Enabled := S;
  SpinEditH.Enabled := S;
  //SpinEditZ.Enabled := S;
  Edit3.Enabled := S;
  Label1.Enabled := S;
  Label2.Enabled := S;
  Label3.Enabled := S;
  Label4.Enabled := S;
  //Label5.Enabled := S;
  //Label8.Enabled := S;
  Label9.Enabled := S;
  Label10.Enabled := S;
  Label11.Enabled := S;
  Button1.Enabled := S;
end;

procedure TMainForm.DrawField(Field: TDoubleBooleanArray);
var
  i, j: integer;
begin
  for i := Low(Field) to High(Field) do
  begin
    for j := Low(Field[i]) to High(Field[i]) do
    begin
       PlayForm.DrawDot(i, j, Field[i][j]);
    end;
  end;
  Application.ProcessMessages;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Randomize;
end;

// http://snippets.dzone.com/posts/show/2937
function IsInteger(S: String): Boolean;
begin
  try
    Result := True;
    StrToInt(S);
  except on E: EConvertError do
    Result := False;
  end;
end;

procedure TMainForm.SpinEditChange(Sender: TObject);
begin
  // Auf Vernderungen von W und H wird nicht eingegangen
  // (man msste das Spielfeld-Array dann verndern)

  if not PlayForm.Visible then exit;

  // Bug-Workaround: Fehler, wenn man eine neue Zahl ber die Tastatur eingibt
  // Fr eine kurze Zeit wre Text='' und damit kein Integer
  if not IsInteger(SpinEditW.Text) then exit;
  if not IsInteger(SpinEditH.Text) then exit;
  if not IsInteger(SpinEditZ.Text) then exit;

  PlayForm.Prepare(SpinEditW.Value, SpinEditH.Value, SpinEditZ.Value);
end;

end.
