unit Playground;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TPlayForm = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    Zoom: integer;
  public
    { Public-Deklarationen }
    procedure UpdateCaption(C: integer);
    procedure Prepare(W, H, Z: integer);
    procedure DrawDot(X, Y: integer; S: boolean);
  end;

var
  PlayForm: TPlayForm;

implementation

uses
  Main;

{$R *.dfm}

resourcestring
  LNG_CELL_CULTURE = 'Zellkultur [Generation %d]';

function BooleanColor(Value: boolean): TColor;
begin
  if Value then
    result := clGreen
  else
    result := clGray;
end;

procedure TPlayForm.DrawDot(X, Y: integer; S: boolean);
begin
  if Zoom = 1 then
  begin
    Image1.Canvas.Pixels[X, Y] := BooleanColor(S);
  end
  else
  begin
    Image1.Canvas.Brush.Style := bsSolid;
    Image1.Canvas.Brush.Color := BooleanColor(S);
    Image1.Canvas.Pen.Color   := BooleanColor(S);

    Image1.Canvas.Rectangle(Zoom*X,      Zoom*Y,
                            Zoom*X+Zoom, Zoom*Y+Zoom);
  end;
end;

procedure TPlayForm.FormCreate(Sender: TObject);
begin
  // DoubleBuffered := true;
end;

procedure TPlayForm.Prepare(W, H, Z: integer);
begin
  Zoom := Z;

  Image1.Width  := W*Zoom;
  Image1.Height := H*Zoom;

  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBlack;
  Image1.Canvas.Pen.Color   := clBlack;

  Image1.Picture.Graphic.Width := Image1.Width;
  Image1.Picture.Graphic.Height := Image1.Height;

  Image1.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);

  // Visible := true;
end;

procedure TPlayForm.UpdateCaption(C: integer);
begin
  Caption := Format(LNG_CELL_CULTURE, [C]);
end;

procedure TPlayForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MainForm.Close;
end;

end.
