unit Stats;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TStatForm = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    C: integer;
  public
    { Public-Deklarationen }
    procedure DrawVal(L: integer; P: Extended);
    procedure Prepare();
  end;

var
  StatForm: TStatForm;

implementation

uses
  Main;

{$R *.dfm}

{ TStatForm }

const
  CL_BACK = clWhite;
  CL_FORE = clRed;
  Abstand = 1;
  LNG_CAP = 'Verlauf [%d cells = %f %%]';

procedure TStatForm.DrawVal(L: integer; P: Extended);
begin
  Image1.Width := C + 1;

  Image1.Picture.Graphic.Width := Image1.Width;
  // Image1.Picture.Graphic.Height := Image1.Height;

  Image1.Canvas.Pixels[C, Image1.Height - Round(P*100*(Image1.Height/100)) ] := CL_FORE;

  Caption := Format(LNG_CAP, [L, P*100]);

  if CheckBox1.Checked then
  begin
    StatForm.ScrollBox1.HorzScrollBar.Position :=
      StatForm.ScrollBox1.HorzScrollBar.Position + 1 + Abstand;
  end;

  Inc(C, 1 + Abstand);
end;

procedure TStatForm.Prepare();
begin
  C := 0;

  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := CL_BACK;
  Image1.Canvas.Pen.Color := CL_BACK;
  Image1.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);

  Image1.Width := 0;

  // Visible := true;
end;

procedure TStatForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MainForm.Close;
end;

end.
